using System;
using System.Text;
using System.Collections.Generic;

namespace Esempio1
{
    public class Digits : List<Digit>
    {
        public static implicit operator string(Digits digits)
        {
            StringBuilder sb = new StringBuilder();
            foreach (Digit digit in digits)
                sb.Append((char) digit);
            return sb.ToString();
        }

        public static explicit operator Digits(string value)
        {
            Digits digits = new Digits();
            foreach (char c in value)
                digits.Add((Digit) c);
            return digits;
        }

        public override string ToString()
        {
            return this;
        }
    }
}
