using System;
using System.Collections;

namespace Esempio1
{
    class Program
    {
        static void Main(string[] args)
        {
            //Step1();
            //Step2();
            //Step3();
            //Step4();
            StringTest1();
            //Step5();
            //Step6();
        }

        private static void Step1()
        {
            Random random = new Random();
            Point[] points = new Point[10];
            //foreach (Point point in points)
            //    point = new Point(random.Next(0, 100), random.Next(0, 100));
            for (int k = 0; k < points.Length; k++)
                points[k] = new Point(random.Next(0, 100), random.Next(0, 100));
            foreach (Point point in points)
                Console.WriteLine("{0}", point);

            //Array.Sort(points);
            //Array.Sort(points, new Point.Comparer(false));
            Array.Sort(points, new Comparer(false));
            Console.WriteLine("-- punti ordinati --");
            foreach (Point point in points)
                Console.WriteLine("{0}", point);
            Console.WriteLine("----");
        }

        private static void Step2()
        {
            int[] array = new int[] { 23, 12, 54, 23, 65, 1 };
            foreach (int value in array)
                Console.WriteLine("{0}", value);
            Array.Sort(array, new Comparer(false));
            Console.WriteLine("-- valori ordinati --");
            foreach (int value in array)
                Console.WriteLine("{0}", value);
            Console.WriteLine("----");
        }

        private static void Step3()
        {
            Digit digit = (Digit) 5;
            char c = digit;
            Console.WriteLine("{0}", c);
            Console.WriteLine("----");
            Digits digits = new Digits();
            for (int k = 0; k <= 9; k++)
                digits.Add((Digit) k);
            Console.WriteLine("{0}", digits);
            Console.WriteLine("{0}", digits[4]);
            Console.WriteLine("----");
            digits = (Digits) "0987654321";
            Console.WriteLine("{0}", digits);
            Console.WriteLine("{0}", digits[4]);
            Console.WriteLine("----");
        }

        private static void Step4()
        {
            Color c = Color.Black;
            for (int k = 0; k < 10; k++)
            {
                Console.WriteLine(c);
                //Console.WriteLine(Enum.Format(typeof(Color), c, "F"));
                c++;
            }
            Console.WriteLine("------------");
            foreach (string s in Enum.GetNames(typeof(Color)))
                Console.WriteLine(s);
            Console.WriteLine("------------");
            foreach (int v in Enum.GetValues(typeof(Color)))
                Console.WriteLine(v);
        }

        private static void StringTest1()
        {
            string a = "a";
            string b = "b";
            string ab = "ab";
            string ab1 = "a" + "b";
            string ab2 = a + b;
            string ab3 = String.Intern(a + b);

            Console.WriteLine("ab -> \"{0}\"", ab);
            Console.WriteLine("ab1 -> \"{0}\"", ab1);
            Console.WriteLine("ab2 -> \"{0}\"", ab2);
            Console.WriteLine("ab3 -> \"{0}\"", ab3);
            Console.WriteLine("------------");
            Console.WriteLine("ab == ab1 -> {0}", ab == ab1);
            Console.WriteLine("ab == ab2 -> {0}", ab == ab2);
            Console.WriteLine("ab == ab3 -> {0}", ab == ab3);
            Console.WriteLine("------------");
            Console.WriteLine("ab.Equals(ab1) -> {0}", ab.Equals(ab1));
            Console.WriteLine("ab.Equals(ab2) -> {0}", ab.Equals(ab2));
            Console.WriteLine("ab.Equals(ab3) -> {0}", ab.Equals(ab3));
            Console.WriteLine("------------");
            Console.WriteLine("Object.Equals(ab, ab1) -> {0}", Object.Equals(ab, ab1));
            Console.WriteLine("Object.Equals(ab, ab2) -> {0}", Object.Equals(ab, ab2));
            Console.WriteLine("Object.Equals(ab, ab3) -> {0}", Object.Equals(ab, ab3));
            Console.WriteLine("------------");
            Console.WriteLine("Object.ReferenceEquals(ab, ab1) -> {0}", Object.ReferenceEquals(ab, ab1));
            Console.WriteLine("Object.ReferenceEquals(ab, ab2) -> {0}", Object.ReferenceEquals(ab, ab2));
            Console.WriteLine("Object.ReferenceEquals(ab, ab3) -> {0}", Object.ReferenceEquals(ab, ab3));
            Console.WriteLine("------------");
        }

        private static void Step5()
        {
            Contenitore contenitore = new Contenitore('A', 10);
            for (int k = 0; k < contenitore.Length; k++)
                Console.Write(contenitore[k]);
            Console.WriteLine("\n----");
            foreach (char c in contenitore)
                Console.Write(c);
            Console.WriteLine("\n----");
        }

        private static void Step6()
        {
            // Display powers of 2 up to the exponent 8:
            IEnumerable powers = PowerGenerator.GetPowers1(2, 8);
            foreach (int i in powers)
            {
                foreach (int j in powers)
                {
                    Console.WriteLine("{0} {1}", i, j);
                }
                Console.WriteLine("------------");
            }
        }
    }
}